"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var HidUsbGateway = /** @class */ (function () {
    function HidUsbGateway(usbProvider, usbModel) {
        this.usbProvider = usbProvider;
        this.usbModel = usbModel;
        this.usbProvider.setDriverType('libusb');
    }
    HidUsbGateway.prototype.getUsbDevices = function () {
        var _this = this;
        return this.usbProvider
            .devices()
            .filter(function (device) { return device.usage !== 1; })
            .map(function (device) { return new _this.usbModel(device); });
    };
    HidUsbGateway.prototype.getHeadphoneByVendorIdAndProductId = function (vendorId, productId) {
        return new this.usbModel(undefined, vendorId, productId);
    };
    return HidUsbGateway;
}());
exports.default = HidUsbGateway;
