"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
var known_headphone_1 = __importDefault(require("../../models/known_headphone"));
var _7x_builder_1 = __importDefault(require("./7x_builder"));
var Builder = /** @class */ (function () {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    function Builder(report, path, knownHeadphone) {
        this.report = report;
        this.path = path;
        this.knownHeadphone = knownHeadphone;
        switch (this.knownHeadphone.productId) {
            case known_headphone_1.default.Arctis7XProductID:
                this.specificBuilder = new _7x_builder_1.default();
                break;
        }
    }
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    Builder.build = function (report, path, knownHeadphone) {
        var builder = new Builder(report, path, knownHeadphone);
        var simpleHeadphone = builder.execute();
        return simpleHeadphone;
    };
    Builder.prototype.execute = function () {
        var headphone = {
            modelName: this.knownHeadphone.name,
            batteryPercent: this.report[this.knownHeadphone.batteryPercentIdx],
            path: this.path
        };
        if (this.specificBuilder) {
            headphone = Object.assign(this.specificBuilder.execute(this.report, this.knownHeadphone), headphone);
        }
        return headphone;
    };
    return Builder;
}());
exports.default = Builder;
